#ifdef WIN32
  #include <io.h>
  #define open _open
  #define read _read
  #define write _write
  #define close _close
  #define MAXPATHLEN 128
#else
  #include <sys/param.h>
#endif

#include <fcntl.h>

#include "SimpleFile.h"

#define LOCAL_PATH_SEPARATOR '/'

static void fixSeparators(char* p) {
  for (; *p != '\0'; ++p)
    if (*p == SimpleFile_separatorChar)
      *p = LOCAL_PATH_SEPARATOR;
}

long SimpleFile_open(struct HSimpleFile *this) {
  int fd;
  char buffer[MAXPATHLEN];
  javaString2CString(unhand(this)->path, buffer, sizeof(buffer));
  fixSeparators(buffer);
  if ((fd = open(buffer, O_RDWR | O_CREAT, 0664)) < 0)
    return FALSE;
  unhand(this)->fd = fd;
  return TRUE;
}

void SimpleFile_close(struct HSimpleFile *this) {
  close(unhand(this)->fd);
  unhand(this)->fd = -1;
}

long SimpleFile_read(struct HSimpleFile *this, HArrayOfByte *buffer, 
  long count) {
  char *data = unhand(buffer)->body;
  int len = obj_length(buffer);
  int numBytes = (len < count ? len : count);
  if ((numBytes = read(unhand(this)->fd, data, numBytes)) == 0)
    return -1;
  return numBytes;
}

long SimpleFile_write(struct HSimpleFile *this, HArrayOfByte *buffer,
  long count) {
  char *data = unhand(buffer)->body;
  int len = obj_length(buffer);
  return write(unhand(this)->fd, data, (len < count ? len : count));
}
